.\" Copyright (c) 1985, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)sigreturn.2	8.1 (Berkeley) 6/4/93
.\"
.Dd June 4, 1993
.Dt SIGRETURN 2
.Os BSD 4.3
.Sh NAME
.Nm sigreturn
.Nd return from signal
.Sh SYNOPSIS
.Fd #include <signal.h>
.Bd -literal
struct	sigcontext {
	int	sc_onstack;		/* sigstack state to restore */
	int	sc_mask;		/* signal mask to restore */
	int	sc_esp;			/* machine state */
	int	sc_ebp;
	int	sc_isp;
	int	sc_eip;
	int	sc_efl;
	int	sc_es;
	int	sc_ds;
	int	sc_cs;
	int	sc_ss;
	int	sc_edi;
	int	sc_esi;
	int	sc_ebx;
	int	sc_edx;
	int	sc_ecx;
	int	sc_eax;
#  define sc_sp sc_esp
#  define sc_fp sc_ebp
#  define sc_pc sc_eip
#  define sc_ps sc_efl
};
.Ed
.Ft int
.Fn sigreturn "struct sigcontext *scp"
.Sh DESCRIPTION
.Fn Sigreturn
allows users to atomically unmask, switch stacks,
and return from a signal context.
The processes signal mask and stack status are
restored from the context.
The system call does not return;
the users stack pointer, frame pointer, argument pointer,
and processor status longword are restored from the context.
Execution resumes at the specified pc.
This system call is used by the trampoline code and
.Xr longjmp 3
when returning from a signal to the previously executing program.
.Sh NOTES
This system call is not available in 4.2
.Tn BSD
hence it should not be used if backward compatibility is needed.
.Sh RETURN VALUES
If successful, the system call does not return.
Otherwise, a value of -1 is returned and 
.Va errno
is set to indicate the error.
.Sh ERRORS
.Fn Sigreturn
will fail and the process context will remain unchanged
if one of the following occurs.
.Bl -tag -width [EINVAL]
.It Bq Er EFAULT
.Fa Scp
points to memory that is not a valid part of the process
address space.
.It Bq Er EINVAL
The process status longword is invalid or would improperly
raise the privilege level of the process.
.El
.Sh SEE ALSO
.Xr sigvec 2 ,
.Xr setjmp 3
.Sh HISTORY
The
.Fn sigreturn
function call appeared in
.Bx 4.3 .
